/* 
 * echoc.c
 * echo client
 *
 * Bernhard Rabe
 * 06.01.2004
 */
#include <sys/socket.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>
#include <netdb.h>

int main(int argc, char *argv[])
{
  int sock,ret,slen,rlen;
  struct sockaddr_in data_addr;
  char buf[255];
  struct addrinfo hint;
  struct addrinfo *addr;  
  struct hostent *IPs;
  int port;
  
  if(argc<4)
  {
    printf("usage: %s <IP address> <port> <message>\n",argv[0]);
    exit(1);
  }
 
  
  if(-1==(sock=socket(PF_INET,SOCK_STREAM,0)))
  {
     perror("socket");exit(1);
  }

  port=atoi(argv[2]);
  
  bzero(&data_addr,sizeof(data_addr));
  
  data_addr.sin_family=AF_INET;
  data_addr.sin_port=htons(port);
  data_addr.sin_addr.s_addr=inet_addr(argv[1]);
  
  printf("connecting\n");
  if(-1==connect(sock,(struct sockaddr*)&data_addr,sizeof(struct sockaddr_in)))
  {
      perror("connect");exit(1);
  }
  
  sprintf(buf,"%s",argv[3]);
  if(strlen(buf)!=(slen=send(sock,buf,strlen(buf),0)))
  {
     perror("send");
     exit(2);
  }
  printf("sent %d bytes\n",slen);
  
  bzero(buf,sizeof(buf));
  
  if(-1==(rlen=recv(sock,buf,255,0)) )
  {
    perror("recv");
    exit(2);
  }
  printf("Got %d bytes (%s)\n",rlen,buf);
  close(sock);
  
}
