/* 
 * echos.c
 * Echo Server
 * wartet auf eine Verbindung, liest maximal 255 Byte, sendet diese zurck
 * und beendet die Verbindung
 *
 * Da Echo normalerweise auf Port 7 luft und alle ports <1024 nur von root
 * benutzt werden drfen, muss man beim Starten eine Port angeben.
 *
 */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>
#include <netdb.h>

int main(int argc, char *argv[])
{
  int sock,csock,slen,rlen,len;
  struct sockaddr_in serv_addr,client_addr;
  char buf[255];
  struct addrinfo hint;
  struct addrinfo *addr;  
  int port;
  pid_t pid;
  
  if(argc<2)
  {
    printf("usage: %s port\n",argv[0]);
    exit(1);
  }

  bzero(&hint,sizeof(hint));
  
  
  if(-1==(sock=socket(PF_INET,SOCK_STREAM,0)))
  {
     perror("socket");
     exit(2);
  }
  /*test auf gueltigen port wird bind ueberlassen*/
  port=atoi(argv[1]);
   
  /*sockaddr Struktur fuellen*/  
  serv_addr.sin_family=AF_INET;
  serv_addr.sin_port=htons(port);
  serv_addr.sin_addr.s_addr=INADDR_ANY;
  
  /*socket Binden*/
  if(-1==bind(sock,(struct sockaddr*)&serv_addr,sizeof(serv_addr)))
  {
      perror("Bind"); 
      exit(3);
  }
  /*Anzahl wartender Verbindungen setzen*/
  if(-1==listen(sock,5))
  {
      perror("listen");
      exit(4);
  }
  
  printf("waiting for connections\n");  
  
  len=sizeof(client_addr);
  
  /*auf Verbindung warten*/
  while(1)
  {
      /*blockierend auf Verbindungen warten*/
      if(-1==(csock=accept(sock,(struct sockaddr*)&client_addr,&len)))
      {
          perror("accept"); 
          exit(5);
      } 
      /*Kind fuer die Bearbeitung der neuen Verbindung starten*/
      if(-1==(pid=fork()))
      {
          perror("fork");
          exit(6);
      }
      if(pid==0)
          break;
  }
  
  /*Ab hier nur noch das Kind*/
  printf("Connect from %s:%d\n",inet_ntoa((struct in_addr)client_addr.sin_addr),htons(client_addr.sin_port));
  
  bzero(buf,sizeof(buf));
  /*Auf Nachricht warten. Maximal 255 Byte Nachrichten werden gelesen*/
  if(-1==(rlen=recv(csock,buf,255,0)))
  {
      perror("recv");
      exit(7);
  }
  /*nur die Anzahl der Bytes ausgeben, da es keine lesbare Zeichenkette sein muss*/
  printf("Received: %d bytes from %s:%d\n",rlen,inet_ntoa((struct in_addr)client_addr.sin_addr),htons(client_addr.sin_port));  
  
  /*Nachricht zurck Senden*/
  if( rlen != (slen=send(csock,buf,rlen,0)))
  {
    perror("send");
    exit(8);
  }
  /*nur die Anzahl der Bytes ausgeben, da es keine lesbare Zeichenkette sein muss*/
  printf("Sent: %d bytes to %s:%d\n",slen,inet_ntoa((struct in_addr)client_addr.sin_addr),htons(client_addr.sin_port));  
  printf("Closing connection %s:%d\n",inet_ntoa((struct in_addr)client_addr.sin_addr),htons(client_addr.sin_port));
  
  if(-1==close(csock))
  {
      perror("close");
      exit(9);
  }
  return 0;
  
}
