/*
 * list.c Linux
 * Simple Dir
 * Bernhard Rabe
 * 06.01.2005
 */
#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>


int main(int argc, char *argv[])
{
    DIR *hFirst;
    struct dirent *fData;
    char found=0;
    char path[1000];
    
    if(argc<2)
    {
        printf("usage: %s path\n",argv[0]);
        exit(1);
    }
    /* change to target directory because stat needs a full path, 
       if items not in the current directory*/
    if(-1==chdir(argv[1]))
    {
        perror("chdir");
        exit(2);
    }
     
    hFirst=opendir(".");
     
    if(NULL==hFirst)
    {
        perror("opendir");
        exit(3);
    }
	
    while(NULL!=(fData=readdir(hFirst)))
    {
        struct stat f_stat;
        
        if(-1==stat(fData->d_name,&f_stat))
        {
            perror("stat");
            exit(4);
        }        
           
        printf("%s\t%s\n",S_ISDIR(f_stat.st_mode)?"DIR":"",fData->d_name);
    }       
    if(-1==closedir(hFirst))
    {
        perror("closedir");
        exit(5);
    }
    
    return 0;
}
